# Tock OT Notes 2/14/2020

Present:
- Laura Abbott, Oxide Computer
- Brad Campbell (Chair),  University of Virginia
- Jon Flatley, Google
- Alistair Francis, Western Digital
- Garret Kelly, Google
- Philip Levis, Stanford University/Google
- Patrick Mooney, Oxide Computer

## TODO
- @alistair23: Document PMP testing strategy on QEMU
- @bradjc: integrate elf2tab header offset into libtock-c/riscv
- All: review OpenTitan peripheral design docs
  - Provide comments to OT HW team

## Summary of Goal Brainstorming
- Setting up software validation and CI
  - Extending the TravisCI setup we have for Tock already?
- Continuing to push bug reports to OT HW developers
- How to leverage Device Interface Functions (DIFs) to develop Tock peripheral drivers
  - Want to use DIFs initially and switch to full Rust versions later
  - Should there be an API inside a peripheral driver to allow easy switching between DIF (in C) and a Rust implementation?
  - Need a structure for using existing Tock crates with DIF-based drivers
- Managing relocations for apps
  - NxK approach workable, but far from desirable
  - LLVM PIC a better option
  - Still unclear what the developer effort would be
  - Need to follow up with @jrvanwhy

## Discussion
- Should we keep arty-e21 platform?
  - Useful as the only M/U mode core
  - Once we have a suitable replacement platform likely can remove arty-e21
  - Might be useful to keep CLIC driver
- Work coordination
  - Weekly call to keep track of generally what people are working on
  - OK to have multiple implementations if conflicts happen


